Class.create(function(Super)
 /**
  * ExceptionNX
  * @param Super [Function|null] X[p[NX
  * @return Function js.debug.jsem.ExceptionNX
  * 
  * @package js.debug.jsem
  * @update 2007/06/15
  * @version 2.00.00
  * @author Mug
  * @copyright (C) 2006-2007 Mug, All rights reserved.
  * 
  * @explanation <p>̃NXJavaScriptErrorManagerpbP[WɂG[NX̊NXłB
  *   ECMAScriptɂĂ̓lCeBuł̓G[(Error)݂͑邪AO(Exception)݂͑ȂB
  *   ̃NX܂͂̃NXpTuNXł́AlCeBuG[Ƌʂ邽߂ɖ̂"Exception"gp邪A
  *   ̓lCeBuG[(Error)NXijs.cpt.ErrorNXoRājpĂ邽߁A
  *   ̃NX₻̃CX^X̓G[ƂĈׂłB</p>
  *   <dl>
  *     <dt>o^</dt>
  *     <dd><samp>Exception</samp></dd>
  *     <dt>bZ[WtH[}bg</dt>
  *     <dd><samp>Exception:{0}</samp></dd>
  *   </dl>
  *   <p>̃NXł̓bZ[WϊƃX^bNg[X̎WŝŁA
  *   TuNXł̓bZ[WtH[}bg(<var>MESSAGE_FORMAT</var>)̃I[o[Ch
  *   i<var>parseMessage</var>\bĥI[o[ChĂ悢jƁA
  *   Ǝ̓o^iNX𐄏j<var>js.cpt.Error</var>NXɓo^΂悢B</p>
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "js.debug.jsem.Exception";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  // js.debug.jsem.trace.StackTrace̎Q
  var StackTrace = js.debug.jsem.trace.StackTrace;
  
  //##############################################################################
  //
  // {fB(vCx[gENXEStaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //------------------------------------------------------------------------------
  function transformMessage(format, params)
   /**
    * tH[}bgwp[^[ŕϊăbZ[W𐶐
    * @param format String bZ[WtH[}bg
    * @param params Object|Array p[^[IuWFNg
    * @return String bZ[W
    */
    {
    var reg = /\{(.*?)\}/;
    var msg = "" + format;
    var key, idx, str, map = {};
    while(reg.test(msg))
      {
      reg.exec(msg);
      idx = RegExp.$1;
      key = "{" + idx + "}";
      if(map[key])
        {
        str = map[key];
        }
      else
        {
        if(!isNaN(idx) && (params instanceof Array))
          {
          idx = parseInt(idx);
          str = ((0 <= idx) && (idx < params.length)) ? ("" + params[idx]) : "";
          }
        else
          {
          str = params.hasOwnProperty(idx) ? "" + params[idx] : "";
          }
        while(str.indexOf(key, 0) >= 0)
          {
          str = str.replace(key, "");
          }
        map[key] = str;
        }
      msg = msg.replace(key, str);
      }
    return msg;
    }
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  //:S MESSAGE_FORMAT String bZ[WtH[}bg
  Static.MESSAGE_FORMAT = "ERROR:{0}";
  
  //------------------------------------------------------------------------------
  Static.parseMessage = function(message)
   /**
    * bZ[W͂ĕɂ
    * @param message [String|Array|Error|Object] G[bZ[W܂̓G[IuWFNg
    * @return String G[bZ[W
    */
    {
    var msg = "";
    switch(typeof message)
      {
      case "boolean":
      case "number":
      case "string":
        msg += message;
        break;
      case "undefined":
      case "null":
      case "function":
      case "object":
      default:
        if(!message)
          {
          msg += message;
          break;
          }
        if(message.message)
          {
          msg += message.message;
          break;
          }
        else
          {
          var format = "" + (message.format ? message.format : this.MESSAGE_FORMAT);
          var params = message.params ? message.params : message;
          if(format && params)
            {
            msg += transformMessage(format, params);
            }
          else
            {
            msg += message;
            break;
            }
          }
        //break;
      }
    return msg;
    };
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //:P name String G[
  Proto.name = "Exception";
  
  //
  //  - NX`ɂP񂾂s
  //
  // G[NX̓o^
  Super.registErrorClass(Proto.name, Class);
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class(cause, message)
   /**
    * ExceptionNX̃RXgN^
    * @param cause [String] G[
    * @param message [String|Array|Error|Object] G[bZ[W܂̓G[IuWFNg
    * @return js.debug.jsem.Exception CX^X
    */
    {
    // 
    if(arguments.length < 2)
      {
      message = cause;
      cause = null;
      }
    // bZ[Wϊ
    if((message != null) && ((typeof message) != "string"))
      {
      message = this.constructor.Static.parseMessage(message);
      }
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    Super.call(this, this.name, cause, message);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    //:i stackTrace js.debug.jsem.trace.StackTrace X^bNg[X
    this.stackTrace = new StackTrace(arguments.callee);
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    
    return this;
    }
  
  return Class;
  }, js.cpt.Error);

