Class.create(function(Super)
 /**
  * StringFormatExceptionNX
  * @param Super [Function|null] X[p[NX
  * @return Function js.debug.jsem.StringFormatExceptionNX
  * 
  * @package js.debug.jsem
  * @update 2007/08/24
  * @version 1.00.00
  * @author Mug
  * @copyright (C) 2007 Mug, All rights reserved.
  * 
  * @explanation <p>̃NXString^tH[}bgG[iϐ̌^̑jNXłB</p>
  *   <dl>
  *     <dt>o^</dt>
  *     <dd><samp>StringFormatException</samp></dd>
  *     <dt>bZ[WtH[}bg</dt>
  *     <dd><samp>StringFormatException:Variable={variable},Format=String,Value={value},Type={type}</samp></dd>
  *   </dl>
  * @example <p><var>word</var>v~eBu<var>String</var>^łȂƂɃG[X[B
  *   <pre><code>
  *   // ϐ"Creator.CompleteName"ɊSCNX`Ă̂ƂB
  *   
  *   function search(word) {
  *     
  *     if((typeof word) != "string") {
  *       throw new Error("StringFormatException", Creator.CompleteName, {variable:"word", value:word, type:(typeof word)});
  *     }
  *     
  *     // i㗪j
  *     
  *   }
  *   </code></pre>
  *   ̃\bhɑ΂<br /><kbd>search(50);</kbd><br />sꍇAG[bZ[W<br />
  *   <samp>StringFormatException:Variable=word,Format=String,Value=50,Type=number</samp><br />ƂȂB</p>
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "js.debug.jsem.StringFormatException";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  
  //##############################################################################
  //
  // {fB(vCx[gENXEStaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  //:S MESSAGE_FORMAT String bZ[WtH[}bg
  Static.MESSAGE_FORMAT = "StringFormatException:Variable={variable},Format=String,Value={value},Type={type}";
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //:P name String G[́io^j
  Proto.name = "StringFormatException";
  
  //
  //  - NX`ɂP񂾂s
  //
  // G[NX̓o^
  js.cpt.Error.registErrorClass(Proto.name, Class);
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class(cause, message)
   /**
    * StringFormatExceptionNX̃RXgN^
    * @param cause [String] G[
    * @param message [String|Array|Error|Object] G[bZ[W܂̓G[IuWFNg
    * @return js.debug.jsem.StringFormatException CX^X
    */
    {
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    
    return this;
    }
  
  return Class;
  }, js.debug.jsem.FormatException);

