Class.create(function(Super)
 /**
  * TraceDataNX
  * @param Super [Function|null] X[p[NX
  * @return Function js.debug.jsem.trace.TraceDataNX
  * 
  * @package js.debug.jsem.trace
  * @update 2007/06/16
  * @version 2.00.00
  * @author Mug
  * @copyright (C) 2006-2007 Mug, All rights reserved.
  * 
  * @explanation <p>̃NX́AX^bNg[X̂̊֐sP񕪂̃f[^i[邽߂ɎgpB
  *   CX^X̐StackTraceNX̃CX^XɎIɍŝŁA
  *   ۂɂ̓X^bNg[X̎oɊpB</p>
  * @rel js.debug.jsem.trace.StackTrace
  */
  {
  //##############################################################################
  //
  // wb_(vpeBEpENXpX)
  //
  //
  // vpeB - NXɊւ郁^f[^
  //
  //:V Creator Function NXNG[^[
  var Creator = arguments.callee;
  // SCNX
  Creator.CompleteName = "js.debug.jsem.trace.TraceData";
  
  //
  // p - vg^CvpƊ{õZbg
  //
  // p
  Creator.inherit(Class, Super);
  //:V Static Object StaticIuWFNg
  var Static = Class.Static;
  //:V Proto Object vg^CvIuWFNg
  var Proto = Class.prototype;
  
  //
  // NXpX
  //
  
  //##############################################################################
  //
  // {fB(vCx[gENXEStaticEvg^CvE)
  //
  //
  // vCx[g - NX̔Joƃ\bh(pȂ)
  //
  //:V NativeFunction Function lCeBuFunctionRXgN^̎Q
  var NativeFunction = (function(){}).constructor;
  
  //------------------------------------------------------------------------------
  function valueToString(value)
   /**
    * lP𕶎񉻂
    * @param value Variant l
    * @return String l̕\iX^bNg[X\j
    */
    {
    var str = '';
    switch(typeof value)
      {
      case "null":
      case "undefined":
      case "boolean":
      case "number":
        str += value;
        break;
      case "string":
        str = '"' + value + '"';
        break;
      case "object":
      default:
        str += value;
        //break;
      }
    return str;
    }
  
  //------------------------------------------------------------------------------
  function argumentsToString(args, lineSeparator)
   /**
    * IuWFNg𕶎񉻂
    * @param args Object|Array IuWFNg܂͈̔z
    * @param lineSeparator String sLqꍇ̉sR[h
    * @return String ̕\
    */
    {
    var str = lineSeparator ? "" : "arguments=[";
    for(var i = 0; i < args.length; i++)
      {
      if(lineSeparator)
        {
        str += "arguments[" + i + "]=" + valueToString(args[i]) + lineSeparator;
        }
      else
        {
        if(i > 0)
          {
          str += ", ";
          }
        str += valueToString(args[i]);
        }
      }
    if(!lineSeparator)
      {
      str += "]";
      }
    return str;
    }
  
  //
  // NX - NX̌Joƃ\bh(pȂ)
  //
  
  //
  // Static - NX.StatičJoƃ\bh(p)
  //
  
  //
  // vg^Cv - NX.prototypěJoƃ\bh(p)
  //
  //------------------------------------------------------------------------------
  Proto.toString = function(lineSeparator, isMultiLines)
   /**
    * X^bNg[Xf[^̕\(ftHg)擾
    * @param lineSeparator [String|null] XgLqꍇ̉sR[h
    * @param isMultiLines [Boolean] ֐\[X𕡐sLq邩ǂ
    * @return String X^bNg[Xf[^̕\(ftHg)
    * @explanation <p>Əo͓e͈ȉ̒ʂBi~null܂͋󕶎ȂǂA͂Pȏ̕\Bj</p>
    *   <table border="1" cellspacing="0">
    *     <thead>
    *       <tr style="background-color:#FFEEDD;"><th colspan="2"></th><th rowspan="2">߂l</th></tr>
    *       <tr style="background-color:#FFEEDD;"><th>lineSeparator</th><th>isMultiLines</th></tr>
    *     </thead>
    *     <tbody>
    *       <tr><th>~</th><th>~</th><td>֐̂Ps</td></tr>
    *       <tr><th></th><th>~</th><td>֐̂Psځ{Xg</td></tr>
    *       <tr><th></th><th></th><td>֐S\[X{Xg</td></tr>
    *       <tr><th>~</th><th></th><td>֐S\[X</td></tr>
    *     </tbody>
    *   </table>
    */
    {
    var str = "";
    var src = this.getSource();
    if(src && !isMultiLines)
      {
      if((/^[\s\r\n\t]*/).test(src))
        {
        (/^([\s\r\n\t]*)/).exec(src);
        src = src.substring(RegExp.$1.length, src.length);
        }
      var r = src.indexOf("\r", 0);
      var n = src.indexOf("\n", 0);
      var s = src.indexOf(")", src.indexOf("(", 0));
      if(r < 0)
        {
        r = src.length;
        }
      if(n < 0)
        {
        n = src.length;
        }
      if(s < 0)
        {
        s = src.length;
        }
      else
        {
        s += 1;
        }
      src = src.substring(0, Math.min(Math.min(r, n), s));
      }
    if(src)
      {
      str += src;
      var arg = this.getArguments();
      if(arg && lineSeparator)
        {
        str += lineSeparator;
        if(!isMultiLines)
          {
          str += "  ";
          }
        str += argumentsToString(arg, (isMultiLines ? lineSeparator : null));
        }
      }
    return str;
    };
  
  //
  //  - NX`ɂP񂾂s
  //
  
  //##############################################################################
  //
  // RXgN^(vCx[gEthisERXgN^)
  //
  function Class(func, args)
   /**
    * TraceDataNX̃RXgN^
    * @param func Function s֐
    * @param args Object s̈IuWFNgiargs.calee֐Ȃ΂funcłȂ΂ȂȂj
    * @return js.debug.jsem.trace.TraceData CX^X
    * @notice <p><var>args</var>ɂĂ炳IuWFNg֐̎ŝ̂łĂA
    *   e̒l͕ύXĂ\Bis֐ł̏eɈˑBj</p>
    */
    {
    //
    // X[p[NXKp(p) - X[p[NX̃RXgN^N
    //
    //Super.apply(this, arguments);
    //
    // vCx[g - CX^X̔Joƃ\bh(pȂ)
    //
    //:v funcRef Function|null s֐(Q)
    var funcRef = null;
    //:v funcStr String|null s֐()
    var funcStr = null;
    //:v argsRef Object|null s̈IuWFNg(Q)
    var argsRef = null;
    //:v argsRefList Array|null s̊e(Q)̃Xg
    var argsRefList = null;
    //:v argsStrList Array|null s̊e()̃Xg
    var argsStrList = null;
    
    //
    // this - CX^X̌Joƃ\bh(Kpɂp)
    //
    //------------------------------------------------------------------------------
    this.getFunction = function()
     /**
      * s֐̎QƂ擾
      * @return Function|null s֐(Q)
      */
      {
      return funcRef;
      };
    //------------------------------------------------------------------------------
    this.getSource = function()
     /**
      * s֐̃\[X𕶎Ŏ擾
      * @return String|null s֐()
      */
      {
      return funcStr;
      };
    //------------------------------------------------------------------------------
    this.getArguments = function()
     /**
      * ֐s̈IuWFNg(Q)擾
      * @return Object|null ֐s̈IuWFNg(Q)
      * @notice <p>߂l͊֐s̈IuWFNĝ̂łB
      *   Ae̒l͊֐̎sɂύXĂ\B
      *   iύX̗L⌋ʂ́A֐̏eɈˑBj</p>
      */
      {
      return argsRef;
      };
    //------------------------------------------------------------------------------
    this.getArgsRefList = function()
     /**
      * ֐s̊e(Q)̔z擾
      * @return Array|null ֐s̊e(Q)̔z
      * @notice <p>e̒l͊֐̎sɂύXĂ\B
      *   iύX̗L⌋ʂ́A֐̏eɈˑBj</p>
      */
      {
      return argsRefList;
      };
    //------------------------------------------------------------------------------
    this.getArgsStrList = function()
     /**
      * ֐s̊e()̔z擾
      * @return Array ֐s̊e()̔z
      */
      {
      return argsStrList;
      };
    
    //
    // RXgN^ - CX^X̌Joƃ\bh(pȂ)
    //
    // ֐i[
    if((typeof func) == "function")
      {
      funcRef = func;
      funcStr = "" + NativeFunction.prototype.toString.apply(func);
      }
    // i[
    if(((typeof args) == "object") && ((args.callee == func) || ((typeof args.callee) != "function")))
      {
      argsRef = args;
      argsRefList = [];
      argsStrList = [];
      if((typeof args.length) == "number")
        {
        for(var i = 0; i < args.length; i++)
          {
          argsRefList[i] = args[i];
          argsStrList[i] = "" + args[i];
          }
        delete i;
        }
      }
    return this;
    }
  
  return Class;
  });

